// Copyright (c) 2002 Cunningham & Cunningham, Inc.
// Released under the terms of the GNU General Public License version 2 or later.

using System;
using System.Reflection;

namespace fit
{

	public class ActionFixture : Fixture 
	{
		Parse cells;
		static Fixture actor;

		// Traversal ////////////////////////////////

		public override void doCells(Parse cells) 
		{
			this.cells = cells;
			try 
			{
				MethodInfo action = GetType().GetMethod(cells.text(), new Type[] {});
				action.Invoke(this, new Type[] {});
			} 
			catch (Exception e) 
			{
				exception(cells, e);
			}
		}

		// Actions //////////////////////////////////

		public void start() 
		{
			actor = loadFixture(cells.more.text());
		}

		public void enter() 
		{
			MethodInfo method = findMethod(1);
			Type type = method.GetParameters()[0].ParameterType;
			String text = cells.more.more.text();
			Object[] args = {TypeAdapter.on(actor, type).parse(text)};
			method.Invoke(actor, args);
		}

		public void press() 
		{
			findMethod(0).Invoke(actor, new Type[] {});
		}

		public void check() 
		{
			TypeAdapter adapter = TypeAdapter.on(actor, findMethod(0));
			check (cells.more.more, adapter);
		}

		// Utility //////////////////////////////////

		MethodInfo findMethod(int args) 
		{
			MethodInfo[] methods = actor.GetType().GetMethods();
			String test = camel(cells.more.text());
			foreach (MethodInfo m in methods)
			{
				if (m.Name.ToLower() == test.ToLower() && m.GetParameters().Length == args) 
				{
					return m;
				}
			}
			throw new MissingMethodException(actor.GetType().Name, test);
		}
	}
}