using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace eg.music
{
	/// <summary>
	/// Summary description for BrowserForm.
	/// </summary>
	public class BrowserForm : System.Windows.Forms.Form
	{
		private Music[] _displayedSongs;

		private System.Windows.Forms.Label lblLibrary;
		private System.Windows.Forms.TextBox txtLibrary;
		private System.Windows.Forms.Button btnLoadLibrary;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.ListView displayListView;
		private System.Windows.Forms.ColumnHeader colTitle;
		private System.Windows.Forms.ColumnHeader colArtist;
		private System.Windows.Forms.GroupBox groupBox;
		private System.Windows.Forms.Button btnAlbum;
		private System.Windows.Forms.Button btnArtist;
		private System.Windows.Forms.Button btnGenre;
		private System.Windows.Forms.Button btnYear;
		private System.Windows.Forms.Button btnAll;
		private System.Windows.Forms.ColumnHeader colGenre;
		private System.Windows.Forms.ColumnHeader colYear;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public BrowserForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lblLibrary = new System.Windows.Forms.Label();
			this.txtLibrary = new System.Windows.Forms.TextBox();
			this.btnLoadLibrary = new System.Windows.Forms.Button();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.displayListView = new System.Windows.Forms.ListView();
			this.colTitle = new System.Windows.Forms.ColumnHeader();
			this.colArtist = new System.Windows.Forms.ColumnHeader();
			this.groupBox = new System.Windows.Forms.GroupBox();
			this.btnAlbum = new System.Windows.Forms.Button();
			this.btnArtist = new System.Windows.Forms.Button();
			this.btnGenre = new System.Windows.Forms.Button();
			this.btnYear = new System.Windows.Forms.Button();
			this.btnAll = new System.Windows.Forms.Button();
			this.colGenre = new System.Windows.Forms.ColumnHeader();
			this.colYear = new System.Windows.Forms.ColumnHeader();
			this.groupBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// lblLibrary
			// 
			this.lblLibrary.AutoSize = true;
			this.lblLibrary.Location = new System.Drawing.Point(12, 16);
			this.lblLibrary.Name = "lblLibrary";
			this.lblLibrary.Size = new System.Drawing.Size(42, 13);
			this.lblLibrary.TabIndex = 0;
			this.lblLibrary.Text = "Library:";
			// 
			// txtLibrary
			// 
			this.txtLibrary.Location = new System.Drawing.Point(60, 12);
			this.txtLibrary.Name = "txtLibrary";
			this.txtLibrary.Size = new System.Drawing.Size(324, 20);
			this.txtLibrary.TabIndex = 1;
			this.txtLibrary.Text = "..\\..\\MusicTests\\Music.txt";
			// 
			// btnLoadLibrary
			// 
			this.btnLoadLibrary.Location = new System.Drawing.Point(388, 12);
			this.btnLoadLibrary.Name = "btnLoadLibrary";
			this.btnLoadLibrary.TabIndex = 2;
			this.btnLoadLibrary.Text = "&Load";
			this.btnLoadLibrary.Click += new System.EventHandler(this.btnLoadLibrary_Click);
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 347);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(476, 22);
			this.statusBar.TabIndex = 3;
			// 
			// displayListView
			// 
			this.displayListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							  this.colTitle,
																							  this.colArtist,
																							  this.colGenre,
																							  this.colYear});
			this.displayListView.Location = new System.Drawing.Point(12, 48);
			this.displayListView.Name = "displayListView";
			this.displayListView.Size = new System.Drawing.Size(452, 192);
			this.displayListView.TabIndex = 4;
			this.displayListView.View = System.Windows.Forms.View.Details;
			this.displayListView.SelectedIndexChanged += new System.EventHandler(this.displayListView_SelectedIndexChanged);
			// 
			// colTitle
			// 
			this.colTitle.Text = "Title";
			this.colTitle.Width = 150;
			// 
			// colArtist
			// 
			this.colArtist.Text = "Artist";
			this.colArtist.Width = 150;
			// 
			// groupBox
			// 
			this.groupBox.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.btnAll,
																				   this.btnYear,
																				   this.btnGenre,
																				   this.btnArtist,
																				   this.btnAlbum});
			this.groupBox.Location = new System.Drawing.Point(12, 248);
			this.groupBox.Name = "groupBox";
			this.groupBox.Size = new System.Drawing.Size(452, 88);
			this.groupBox.TabIndex = 6;
			this.groupBox.TabStop = false;
			this.groupBox.Text = "Find Same";
			// 
			// btnAlbum
			// 
			this.btnAlbum.Location = new System.Drawing.Point(16, 36);
			this.btnAlbum.Name = "btnAlbum";
			this.btnAlbum.TabIndex = 6;
			this.btnAlbum.Text = "&Album";
			this.btnAlbum.Click += new System.EventHandler(this.btnAlbum_Click);
			// 
			// btnArtist
			// 
			this.btnArtist.Location = new System.Drawing.Point(98, 36);
			this.btnArtist.Name = "btnArtist";
			this.btnArtist.TabIndex = 7;
			this.btnArtist.Text = "A&rtist";
			this.btnArtist.Click += new System.EventHandler(this.btnArtist_Click);
			// 
			// btnGenre
			// 
			this.btnGenre.Location = new System.Drawing.Point(180, 36);
			this.btnGenre.Name = "btnGenre";
			this.btnGenre.TabIndex = 8;
			this.btnGenre.Text = "&Genre";
			this.btnGenre.Click += new System.EventHandler(this.btnGenre_Click);
			// 
			// btnYear
			// 
			this.btnYear.Location = new System.Drawing.Point(262, 36);
			this.btnYear.Name = "btnYear";
			this.btnYear.TabIndex = 9;
			this.btnYear.Text = "&Year";
			this.btnYear.Click += new System.EventHandler(this.btnYear_Click);
			// 
			// btnAll
			// 
			this.btnAll.Location = new System.Drawing.Point(364, 36);
			this.btnAll.Name = "btnAll";
			this.btnAll.TabIndex = 10;
			this.btnAll.Text = "&Find All";
			this.btnAll.Click += new System.EventHandler(this.btnAll_Click);
			// 
			// colGenre
			// 
			this.colGenre.Text = "Genre";
			this.colGenre.Width = 80;
			// 
			// colYear
			// 
			this.colYear.Text = "Year";
			this.colYear.Width = 50;
			// 
			// BrowserForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(476, 369);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.groupBox,
																		  this.displayListView,
																		  this.statusBar,
																		  this.btnLoadLibrary,
																		  this.txtLibrary,
																		  this.lblLibrary});
			this.Name = "BrowserForm";
			this.Text = "Music Browser";
			this.groupBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void btnLoadLibrary_Click(object sender, System.EventArgs e)
		{
			// load the library
			string path = this.txtLibrary.Text;
			Music.load(path);

			// update status
			int totalSongs = Music.library.Length;
			this.statusBar.Text = string.Format("{0} songs loaded", totalSongs);

			// display songs in listView
			Music.findAll();
			this.LoadListView();
		}

		private void LoadListView() 
		{
			this.displayListView.Items.Clear();
			this._displayedSongs = Music.displayContents();
			foreach (Music song in this._displayedSongs) 
			{	
				ListViewItem item = new ListViewItem(new string[]{song.title, song.artist, song.genre, song.year.ToString()});
				this.displayListView.Items.Add(item);
			}
		}

		private void displayListView_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (this.displayListView.SelectedIndices.Count > 0) 
			{
				int index = this.displayListView.SelectedIndices[0];
				Music.select(this._displayedSongs[index]);
			}
		}

		private void btnAlbum_Click(object sender, System.EventArgs e)
		{
			Music.findAlbum(Music.looking.album);
			this.LoadListView();
		}

		private void btnArtist_Click(object sender, System.EventArgs e)
		{
			Music.findArtist(Music.looking.artist);
			this.LoadListView();
		}

		private void btnGenre_Click(object sender, System.EventArgs e)
		{
			Music.findGenre(Music.looking.genre);
			this.LoadListView();
		}

		private void btnYear_Click(object sender, System.EventArgs e)
		{
			Music.findYear(Music.looking.year);
			this.LoadListView();
		}

		private void btnAll_Click(object sender, System.EventArgs e)
		{
			Music.findAll();
			this.LoadListView();
		}
	}
}
